Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 997)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 1001)
@@ -4,5 +4,5 @@
 ! Current revisions:
 ! -----------------
-!
+! all actions concerning leapfrog- and upstream-spline-scheme removed
 !
 ! Former revisions:
@@ -163,5 +163,5 @@
     CHARACTER (LEN=9) ::  time_to_string
     INTEGER ::  i, i_omp_start, j, k, tn = 0
-    REAL    ::  sat, sbt
+    REAL    ::  sbt
 
 !
@@ -178,13 +178,4 @@
     CALL cpu_log( log_point(5), 'u-equation', 'start' )
 
-!
-!-- u-tendency terms with communication
-    IF ( momentum_advec == 'ups-scheme' )  THEN
-       tend = 0.0
-       CALL advec_u_ups
-    ENDIF
-
-!
-!-- u-tendency terms with no communication
     i_omp_start = nxlu
     DO  i = nxlu, nxr
@@ -192,6 +183,6 @@
 !
 !--       Tendency terms
-          IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
-             tend(:,j,i) = 0.0
+          tend(:,j,i) = 0.0
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_mom )  THEN
                  CALL advec_u_ws( i, j, i_omp_start, tn )
@@ -199,18 +190,8 @@
                  CALL advec_u_pw( i, j )
              ENDIF
-
           ELSE
-             IF ( momentum_advec /= 'ups-scheme' )  THEN
-                tend(:,j,i) = 0.0
-                CALL advec_u_up( i, j )
-             ENDIF
-          ENDIF
-          IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
-             CALL diffusion_u( i, j, ddzu, ddzw, km_m, tend, u_m, usws_m, &
-                               uswst_m, v_m, w_m )
-          ELSE
-             CALL diffusion_u( i, j, ddzu, ddzw, km, tend, u, usws, uswst, &
-                               v, w )
-          ENDIF
+             CALL advec_u_up( i, j )
+          ENDIF
+          CALL diffusion_u( i, j )
           CALL coriolis( i, j, 1 )
           IF ( sloping_surface  .AND.  .NOT. neutral )  THEN
@@ -235,9 +216,7 @@
 !--       Prognostic equation for u-velocity component
           DO  k = nzb_u_inner(j,i)+1, nzt
-             u_p(k,j,i) = ( 1.0-tsc(1) ) * u_m(k,j,i) + tsc(1) * u(k,j,i) +    &
-                          dt_3d * (                                            &
-                                   tsc(2) * tend(k,j,i) + tsc(3) * tu_m(k,j,i) &
-                                  ) -                                          &
-                           tsc(5) * rdf(k) * ( u(k,j,i) - ug(k) )
+             u_p(k,j,i) = u(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +          &
+                                               tsc(3) * tu_m(k,j,i) )          &
+                                   - tsc(5) * rdf(k) * ( u(k,j,i) - ug(k) )
           ENDDO
 
@@ -266,13 +245,4 @@
     CALL cpu_log( log_point(6), 'v-equation', 'start' )
 
-!
-!-- v-tendency terms with communication
-    IF ( momentum_advec == 'ups-scheme' )  THEN
-       tend = 0.0
-       CALL advec_v_ups
-    ENDIF
-
-!
-!-- v-tendency terms with no communication
     i_omp_start = nxl
     DO  i = nxl, nxr
@@ -280,6 +250,6 @@
 !
 !--       Tendency terms
-          IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
-             tend(:,j,i) = 0.0
+          tend(:,j,i) = 0.0
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_mom )  THEN
                  CALL advec_v_ws( i, j, i_omp_start, tn )
@@ -289,16 +259,7 @@
 
           ELSE
-             IF ( momentum_advec /= 'ups-scheme' )  THEN
-                tend(:,j,i) = 0.0
-                CALL advec_v_up( i, j )
-             ENDIF
-          ENDIF
-          IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
-             CALL diffusion_v( i, j, ddzu, ddzw, km_m, tend, u_m, v_m, &
-                               vsws_m, vswst_m, w_m )
-          ELSE
-             CALL diffusion_v( i, j, ddzu, ddzw, km, tend, u, v, vsws, &
-                               vswst, w )
-          ENDIF
+             CALL advec_v_up( i, j )
+          ENDIF
+          CALL diffusion_v( i, j )
           CALL coriolis( i, j, 2 )
 
@@ -320,9 +281,7 @@
 !--       Prognostic equation for v-velocity component
           DO  k = nzb_v_inner(j,i)+1, nzt
-             v_p(k,j,i) = ( 1.0-tsc(1) ) * v_m(k,j,i) + tsc(1) * v(k,j,i) +    &
-                          dt_3d * (                                            &
-                                   tsc(2) * tend(k,j,i) + tsc(3) * tv_m(k,j,i) &
-                                  ) -                                          &
-                          tsc(5) * rdf(k) * ( v(k,j,i) - vg(k) )
+             v_p(k,j,i) = v(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +          &
+                                               tsc(3) * tv_m(k,j,i) )          &
+                                   - tsc(5) * rdf(k) * ( v(k,j,i) - vg(k) )
           ENDDO
 
@@ -351,19 +310,10 @@
     CALL cpu_log( log_point(7), 'w-equation', 'start' )
 
-!
-!-- w-tendency terms with communication
-    IF ( momentum_advec == 'ups-scheme' )  THEN
-       tend = 0.0
-       CALL advec_w_ups
-    ENDIF
-
-!
-!-- w-tendency terms with no communication
     DO  i = nxl, nxr
        DO  j = nys, nyn
 !
 !--       Tendency terms
-          IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
-             tend(:,j,i) = 0.0
+          tend(:,j,i) = 0.0
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_mom )  THEN
                  CALL advec_w_ws( i, j, i_omp_start, tn )
@@ -373,14 +323,7 @@
 
           ELSE
-             IF ( momentum_advec /= 'ups-scheme' )  THEN
-                tend(:,j,i) = 0.0
-                CALL advec_w_up( i, j )
-             ENDIF
-          ENDIF
-          IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )  THEN
-             CALL diffusion_w( i, j, ddzu, ddzw, km_m, tend, u_m, v_m, w_m )
-          ELSE
-             CALL diffusion_w( i, j, ddzu, ddzw, km, tend, u, v, w )
-          ENDIF
+             CALL advec_w_up( i, j )
+          ENDIF
+          CALL diffusion_w( i, j )
           CALL coriolis( i, j, 3 )
 
@@ -406,9 +349,7 @@
 !--       Prognostic equation for w-velocity component
           DO  k = nzb_w_inner(j,i)+1, nzt-1
-             w_p(k,j,i) = ( 1.0-tsc(1) ) * w_m(k,j,i) + tsc(1) * w(k,j,i) +    &
-                          dt_3d * (                                            &
-                                   tsc(2) * tend(k,j,i) + tsc(3) * tw_m(k,j,i) &
-                                  ) -                                          &
-                          tsc(5) * rdf(k) * w(k,j,i)
+             w_p(k,j,i) = w(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +          &
+                                               tsc(3) * tw_m(k,j,i) )          &
+                                   - tsc(5) * rdf(k) * w(k,j,i)
           ENDDO
 
@@ -439,39 +380,28 @@
        CALL cpu_log( log_point(13), 'pt-equation', 'start' )
 
-   !
-   !-- pt-tendency terms with communication
-       sat = tsc(1)
+!
+!--    pt-tendency terms with communication
        sbt = tsc(2)
        IF ( scalar_advec == 'bc-scheme' )  THEN
 
           IF ( timestep_scheme(1:5) /= 'runge' )  THEN
-   !
-   !--       Bott-Chlond scheme always uses Euler time step when leapfrog is
-   !--       switched on. Thus:
-             sat = 1.0
+!
+!--          Bott-Chlond scheme always uses Euler time step. Thus:
              sbt = 1.0
           ENDIF
           tend = 0.0
           CALL advec_s_bc( pt, 'pt' )
-       ELSE
-          IF ( tsc(2) /= 2.0  .AND.  scalar_advec == 'ups-scheme' )  THEN
-             tend = 0.0
-             CALL advec_s_ups( pt, 'pt' )
-          ENDIF
-       ENDIF
-
-   !
-   !-- pt-tendency terms with no communication
+
+       ENDIF
+
+!
+!--    pt-tendency terms with no communication
        DO  i = nxl, nxr
           DO  j = nys, nyn
-   !
-   !--       Tendency terms
-             IF ( scalar_advec == 'bc-scheme' )  THEN
-                CALL diffusion_s( i, j, ddzu, ddzw, kh, pt, shf, tswst, &
-                                  wall_heatflux, tend )
-             ELSE
-                IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' ) &
-                THEN
-                   tend(:,j,i) = 0.0
+!
+!--          Tendency terms
+             IF ( scalar_advec /= 'bc-scheme' )  THEN
+                tend(:,j,i) = 0.0
+                IF ( timestep_scheme(1:5) == 'runge' )  THEN
                    IF ( ws_scheme_sca )  THEN
                       CALL advec_s_ws( i, j, pt, 'pt', flux_s_pt,       &
@@ -482,40 +412,31 @@
                    ENDIF
                 ELSE
-                   IF ( scalar_advec /= 'ups-scheme' )  THEN
-                      tend(:,j,i) = 0.0
-                      CALL advec_s_up( i, j, pt )
-                   ENDIF
-                ENDIF
-                IF ( tsc(2) == 2.0 .AND. timestep_scheme(1:8) == 'leapfrog' ) &
-                THEN
-                   CALL diffusion_s( i, j, ddzu, ddzw, kh_m, pt_m, shf_m, &
-                                     tswst_m, wall_heatflux, tend )
-                ELSE
-                   CALL diffusion_s( i, j, ddzu, ddzw, kh, pt, shf, tswst, &
-                                     wall_heatflux, tend )
-                ENDIF
-             ENDIF
-
-   !
-   !--       If required compute heating/cooling due to long wave radiation
-   !--       processes
+                   CALL advec_s_up( i, j, pt )
+                ENDIF
+             ENDIF
+
+             CALL diffusion_s( i, j, pt, shf, tswst, wall_heatflux )
+
+!
+!--          If required compute heating/cooling due to long wave radiation
+!--          processes
              IF ( radiation )  THEN
                 CALL calc_radiation( i, j )
              ENDIF
 
-   !
-   !--       If required compute impact of latent heat due to precipitation
+!
+!--          If required compute impact of latent heat due to precipitation
              IF ( precipitation )  THEN
                 CALL impact_of_latent_heat( i, j )
              ENDIF
 
-   !
-   !--       Consideration of heat sources within the plant canopy
+!
+!--          Consideration of heat sources within the plant canopy
              IF ( plant_canopy .AND. ( cthf /= 0.0 ) ) THEN
                 CALL plant_canopy_model( i, j, 4 )
              ENDIF
 
-   !
-   !--       If required compute influence of large-scale subsidence/ascent
+!
+!--          If required compute influence of large-scale subsidence/ascent
              IF ( large_scale_subsidence )  THEN
                 CALL subsidence( i, j, tend, pt, pt_init )
@@ -524,17 +445,15 @@
              CALL user_actions( i, j, 'pt-tendency' )
 
-   !
-   !--       Prognostic equation for potential temperature
+!
+!--          Prognostic equation for potential temperature
              DO  k = nzb_s_inner(j,i)+1, nzt
-                pt_p(k,j,i) = ( 1 - sat ) * pt_m(k,j,i) + sat * pt(k,j,i) + &
-                              dt_3d * (                                        &
-                                       sbt * tend(k,j,i) + tsc(3) * tpt_m(k,j,i) &
-                                      ) - &
-                              tsc(5) * ( pt(k,j,i) - pt_init(k) ) * &
-                              ( rdf_sc(k) + ptdf_x(i) + ptdf_y(j) )  
-             ENDDO
-
-   !
-   !--       Calculate tendencies for the next Runge-Kutta step
+                pt_p(k,j,i) = pt(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +        &
+                                                    tsc(3) * tpt_m(k,j,i) )    &
+                                        - tsc(5) * ( pt(k,j,i) - pt_init(k) ) *&
+                                          ( rdf_sc(k) + ptdf_x(i) + ptdf_y(j) )
+             ENDDO
+
+!
+!--          Calculate tendencies for the next Runge-Kutta step
              IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( intermediate_timestep_count == 1 )  THEN
@@ -566,5 +485,4 @@
 !
 !--    sa-tendency terms with communication
-       sat = tsc(1)
        sbt = tsc(2)
        IF ( scalar_advec == 'bc-scheme' )  THEN
@@ -572,18 +490,10 @@
           IF ( timestep_scheme(1:5) /= 'runge' )  THEN
 !
-!--          Bott-Chlond scheme always uses Euler time step when leapfrog is
-!--          switched on. Thus:
-             sat = 1.0
+!--          Bott-Chlond scheme always uses Euler time step. Thus:
              sbt = 1.0
           ENDIF
           tend = 0.0
           CALL advec_s_bc( sa, 'sa' )
-       ELSE
-          IF ( tsc(2) /= 2.0 )  THEN
-             IF ( scalar_advec == 'ups-scheme' )  THEN
-                tend = 0.0
-                CALL advec_s_ups( sa, 'sa' )
-             ENDIF
-          ENDIF
+
        ENDIF
 
@@ -594,10 +504,7 @@
 !
 !--          Tendency-terms
-             IF ( scalar_advec == 'bc-scheme' )  THEN
-                CALL diffusion_s( i, j, ddzu, ddzw, kh, sa, saswsb, saswst, &
-                                  wall_salinityflux, tend )
-             ELSE
-                IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' ) THEN
-                   tend(:,j,i) = 0.0
+             IF ( scalar_advec /= 'bc-scheme' )  THEN
+                tend(:,j,i) = 0.0
+                IF ( timestep_scheme(1:5) == 'runge' ) THEN
                    IF ( ws_scheme_sca )  THEN
                        CALL advec_s_ws( i, j, sa, 'sa', flux_s_sa,  &
@@ -608,12 +515,9 @@
 
                 ELSE
-                   IF ( scalar_advec /= 'ups-scheme' )  THEN
-                      tend(:,j,i) = 0.0
-                      CALL advec_s_up( i, j, sa )
-                   ENDIF
-                ENDIF
-                CALL diffusion_s( i, j, ddzu, ddzw, kh, sa, saswsb, saswst, &
-                                  wall_salinityflux, tend )
-             ENDIF
+                   CALL advec_s_up( i, j, sa )
+                ENDIF
+             ENDIF
+
+             CALL diffusion_s( i, j, sa, saswsb, saswst, wall_salinityflux )
        
              CALL user_actions( i, j, 'sa-tendency' )
@@ -622,9 +526,8 @@
 !--          Prognostic equation for salinity
              DO  k = nzb_s_inner(j,i)+1, nzt
-                sa_p(k,j,i) = sat * sa(k,j,i) +                                &
-                              dt_3d * (                                        &
-                                     sbt * tend(k,j,i) + tsc(3) * tsa_m(k,j,i) &
-                                      ) -                                      &
-                              tsc(5) * rdf_sc(k) * ( sa(k,j,i) - sa_init(k) )
+                sa_p(k,j,i) = sa(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +        &
+                                                    tsc(3) * tsa_m(k,j,i) )    &
+                                        - tsc(5) * rdf_sc(k) *                 &
+                                          ( sa(k,j,i) - sa_init(k) )
                 IF ( sa_p(k,j,i) < 0.0 )  sa_p(k,j,i) = 0.1 * sa(k,j,i)
              ENDDO
@@ -665,5 +568,4 @@
 !
 !--    Scalar/q-tendency terms with communication
-       sat = tsc(1)
        sbt = tsc(2)
        IF ( scalar_advec == 'bc-scheme' )  THEN
@@ -671,18 +573,10 @@
           IF ( timestep_scheme(1:5) /= 'runge' )  THEN
 !
-!--          Bott-Chlond scheme always uses Euler time step when leapfrog is
-!--          switched on. Thus:
-             sat = 1.0
+!--          Bott-Chlond scheme always uses Euler time step. Thus:
              sbt = 1.0
           ENDIF
           tend = 0.0
           CALL advec_s_bc( q, 'q' )
-       ELSE
-          IF ( tsc(2) /= 2.0 )  THEN
-             IF ( scalar_advec == 'ups-scheme' )  THEN
-                tend = 0.0
-                CALL advec_s_ups( q, 'q' )
-             ENDIF
-          ENDIF
+
        ENDIF
 
@@ -693,10 +587,7 @@
 !
 !--          Tendency-terms
-             IF ( scalar_advec == 'bc-scheme' )  THEN
-                CALL diffusion_s( i, j, ddzu, ddzw, kh, q, qsws, qswst, &
-                                  wall_qflux, tend )
-             ELSE
-                IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' ) THEN
-                   tend(:,j,i) = 0.0
+             IF ( scalar_advec /= 'bc-scheme' )  THEN
+                tend(:,j,i) = 0.0
+                IF ( timestep_scheme(1:5) == 'runge' ) THEN
                    IF ( ws_scheme_sca )  THEN
                        CALL advec_s_ws( i, j, q, 'q', flux_s_q, &
@@ -706,18 +597,9 @@
                    ENDIF
                 ELSE
-                   IF ( scalar_advec /= 'ups-scheme' )  THEN
-                      tend(:,j,i) = 0.0
-                      CALL advec_s_up( i, j, q )
-                   ENDIF
-                ENDIF
-                IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )&
-                THEN
-                   CALL diffusion_s( i, j, ddzu, ddzw, kh_m, q_m, qsws_m, &
-                                     qswst_m, wall_qflux, tend )
-                ELSE
-                   CALL diffusion_s( i, j, ddzu, ddzw, kh, q, qsws, qswst, &
-                                     wall_qflux, tend )
-                ENDIF
-             ENDIF
+                   CALL advec_s_up( i, j, q )
+                ENDIF
+             ENDIF
+
+             CALL diffusion_s( i, j, q, qsws, qswst, wall_qflux )
        
 !
@@ -743,9 +625,8 @@
 !--          Prognostic equation for total water content / scalar
              DO  k = nzb_s_inner(j,i)+1, nzt
-                q_p(k,j,i) = ( 1 - sat ) * q_m(k,j,i) + sat * q(k,j,i) +       &
-                             dt_3d * (                                         &
-                                      sbt * tend(k,j,i) + tsc(3) * tq_m(k,j,i) &
-                                     ) -                                       &
-                             tsc(5) * rdf_sc(k) * ( q(k,j,i) - q_init(k) )
+                q_p(k,j,i) = q(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +          &
+                                                  tsc(3) * tq_m(k,j,i) )       &
+                                      - tsc(5) * rdf_sc(k) *                   &
+                                        ( q(k,j,i) - q_init(k) )
                 IF ( q_p(k,j,i) < 0.0 )  q_p(k,j,i) = 0.1 * q(k,j,i)
              ENDDO
@@ -784,5 +665,4 @@
        CALL production_e_init
 
-       sat = tsc(1)
        sbt = tsc(2)
        IF ( .NOT. use_upstream_for_tke )  THEN
@@ -791,18 +671,9 @@
              IF ( timestep_scheme(1:5) /= 'runge' )  THEN
 !
-!--             Bott-Chlond scheme always uses Euler time step when leapfrog is
-!--             switched on. Thus:
-                sat = 1.0
+!--             Bott-Chlond scheme always uses Euler time step. Thus:
                 sbt = 1.0
              ENDIF
              tend = 0.0
              CALL advec_s_bc( e, 'e' )
-          ELSE
-             IF ( tsc(2) /= 2.0 )  THEN
-                IF ( scalar_advec == 'ups-scheme' )  THEN
-                   tend = 0.0
-                   CALL advec_s_ups( e, 'e' )
-                ENDIF
-             ENDIF
           ENDIF
        ENDIF
@@ -814,29 +685,11 @@
 !
 !--          Tendency-terms
-             IF ( scalar_advec == 'bc-scheme'  .AND.  &
-                  .NOT. use_upstream_for_tke )  THEN
-                IF ( .NOT. humidity )  THEN
-                   IF ( ocean )  THEN
-                      CALL diffusion_e( i, j, ddzu, dd2zu, ddzw, diss, e, km,  &
-                                        l_grid, prho, prho_reference, rif,     &
-                                        tend, zu, zw )
-                   ELSE
-                      CALL diffusion_e( i, j, ddzu, dd2zu, ddzw, diss, e, km,  &
-                                        l_grid, pt, pt_reference, rif, tend,   &
-                                        zu, zw )
-                   ENDIF
-                ELSE
-                   CALL diffusion_e( i, j, ddzu, dd2zu, ddzw, diss, e, km,     &
-                                     l_grid, vpt, pt_reference, rif, tend, zu, &
-                                     zw )
-                ENDIF
-             ELSE
+             IF ( scalar_advec /= 'bc-scheme' .OR. use_upstream_for_tke )  THEN
                 IF ( use_upstream_for_tke )  THEN
                    tend(:,j,i) = 0.0
                    CALL advec_s_up( i, j, e )
                 ELSE
-                   IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' ) &
-                   THEN
-                      tend(:,j,i) = 0.0
+                   tend(:,j,i) = 0.0
+                   IF ( timestep_scheme(1:5) == 'runge' )  THEN
                       IF ( ws_scheme_sca )  THEN
                           CALL advec_s_ws( i, j, e, 'e', flux_s_e, & 
@@ -846,39 +699,19 @@
                       ENDIF
                    ELSE
-                      IF ( scalar_advec /= 'ups-scheme' )  THEN
-                         tend(:,j,i) = 0.0
-                         CALL advec_s_up( i, j, e )
-                      ENDIF
+                      CALL advec_s_up( i, j, e )
                    ENDIF
                 ENDIF
-                IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' )&
-                THEN
-                   IF ( .NOT. humidity )  THEN
-                      CALL diffusion_e( i, j, ddzu, dd2zu, ddzw, diss, e_m, &
-                                        km_m, l_grid, pt_m, pt_reference,   &
-                                        rif_m, tend, zu, zw )
-                   ELSE
-                      CALL diffusion_e( i, j, ddzu, dd2zu, ddzw, diss, e_m, &
-                                        km_m, l_grid, vpt_m, pt_reference,  &
-                                        rif_m, tend, zu, zw )
-                   ENDIF
+             ENDIF
+
+             IF ( .NOT. humidity )  THEN
+                IF ( ocean )  THEN
+                   CALL diffusion_e( i, j, prho, prho_reference )
                 ELSE
-                   IF ( .NOT. humidity )  THEN
-                      IF ( ocean )  THEN
-                         CALL diffusion_e( i, j, ddzu, dd2zu, ddzw, diss, e,  &
-                                           km, l_grid, prho, prho_reference,  &
-                                           rif, tend, zu, zw )
-                      ELSE
-                         CALL diffusion_e( i, j, ddzu, dd2zu, ddzw, diss, e,  &
-                                           km, l_grid, pt, pt_reference, rif, &
-                                           tend, zu, zw )
-                      ENDIF
-                   ELSE
-                      CALL diffusion_e( i, j, ddzu, dd2zu, ddzw, diss, e, km, &
-                                        l_grid, vpt, pt_reference, rif, tend, &
-                                        zu, zw )
-                   ENDIF
-                ENDIF
-             ENDIF
+                   CALL diffusion_e( i, j, pt, pt_reference )
+                ENDIF
+             ELSE
+                CALL diffusion_e( i, j, vpt, pt_reference )
+             ENDIF
+
              CALL production_e( i, j )
 
@@ -895,8 +728,6 @@
 !--          value is reduced by 90%.
              DO  k = nzb_s_inner(j,i)+1, nzt
-                e_p(k,j,i) = ( 1 - sat ) * e_m(k,j,i) + sat * e(k,j,i) +       &
-                             dt_3d * (                                         &
-                                      sbt * tend(k,j,i) + tsc(3) * te_m(k,j,i) &
-                                     )
+                e_p(k,j,i) = e(k,j,i) + dt_3d * ( sbt * tend(k,j,i) +          &
+                                                  tsc(3) * te_m(k,j,i) )
                 IF ( e_p(k,j,i) < 0.0 )  e_p(k,j,i) = 0.1 * e(k,j,i)
              ENDDO
@@ -986,8 +817,7 @@
 
              tend(:,j,i) = 0.0
-             IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_mom )  THEN
                    IF ( ( inflow_l .OR. outflow_l ) .AND. i_omp_start == nxl )  THEN 
-!                     CALL local_diss( i, j, u)    ! dissipation control
                       CALL advec_u_ws( i, j, i_omp_start + 1, tn )
                    ELSE
@@ -1000,12 +830,5 @@
                 CALL advec_u_up( i, j )
              ENDIF
-             IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' ) &
-             THEN
-                CALL diffusion_u( i, j, ddzu, ddzw, km_m, tend,  u_m, &
-                                  usws_m, uswst_m, v_m, w_m )
-             ELSE
-                CALL diffusion_u( i, j, ddzu, ddzw, km, tend, u, usws, &
-                                  uswst, v, w )
-             ENDIF
+             CALL diffusion_u( i, j )
              CALL coriolis( i, j, 1 )
              IF ( sloping_surface  .AND.  .NOT. neutral )  THEN
@@ -1030,9 +853,7 @@
 !--          Prognostic equation for u-velocity component
              DO  k = nzb_u_inner(j,i)+1, nzt
-                u_p(k,j,i) = ( 1.0-tsc(1) ) * u_m(k,j,i) + tsc(1) * u(k,j,i) + &
-                             dt_3d * (                                         &
-                                   tsc(2) * tend(k,j,i) + tsc(3) * tu_m(k,j,i) &
-                                     ) -                                       &
-                             tsc(5) * rdf(k) * ( u(k,j,i) - ug(k) )
+                u_p(k,j,i) = u(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +       &
+                                                  tsc(3) * tu_m(k,j,i) )       &
+                                      - tsc(5) * rdf(k) * ( u(k,j,i) - ug(k) )
              ENDDO
 
@@ -1059,7 +880,6 @@
 
              tend(:,j,i) = 0.0
-             IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( timestep_scheme(1:5) == 'runge' )  THEN
                 IF ( ws_scheme_mom )  THEN
-                 !   CALL local_diss( i, j, v)
                     CALL advec_v_ws( i, j, i_omp_start, tn )
                 ELSE 
@@ -1069,12 +889,5 @@
                 CALL advec_v_up( i, j )
              ENDIF
-             IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' ) &
-             THEN
-                CALL diffusion_v( i, j, ddzu, ddzw, km_m, tend, u_m, v_m, &
-                                  vsws_m, vswst_m, w_m )
-             ELSE
-                CALL diffusion_v( i, j, ddzu, ddzw, km, tend, u, v, vsws, &
-                                  vswst, w )
-             ENDIF
+             CALL diffusion_v( i, j )
              CALL coriolis( i, j, 2 )
 
@@ -1096,9 +909,7 @@
 !--          Prognostic equation for v-velocity component
              DO  k = nzb_v_inner(j,i)+1, nzt
-                v_p(k,j,i) = ( 1.0-tsc(1) ) * v_m(k,j,i) + tsc(1) * v(k,j,i) + &
-                             dt_3d * (                                         &
-                                   tsc(2) * tend(k,j,i) + tsc(3) * tv_m(k,j,i) &
-                                     ) -                                       &
-                             tsc(5) * rdf(k) * ( v(k,j,i) - vg(k) )
+                v_p(k,j,i) = v(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +       &
+                                                  tsc(3) * tv_m(k,j,i) )       &
+                                      - tsc(5) * rdf(k) * ( v(k,j,i) - vg(k) )
              ENDDO
 
@@ -1123,7 +934,6 @@
 !--       Tendency terms for w-velocity component
           tend(:,j,i) = 0.0
-          IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
+          IF ( timestep_scheme(1:5) == 'runge' )  THEN
              IF ( ws_scheme_mom )  THEN
-             !   CALL local_diss( i, j, w)
                 CALL advec_w_ws( i, j, i_omp_start, tn )
              ELSE 
@@ -1133,11 +943,5 @@
              CALL advec_w_up( i, j )
           ENDIF
-          IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' ) &
-          THEN
-             CALL diffusion_w( i, j, ddzu, ddzw, km_m, tend, u_m, v_m, &
-                               w_m )
-          ELSE
-             CALL diffusion_w( i, j, ddzu, ddzw, km, tend, u, v, w )
-          ENDIF
+          CALL diffusion_w( i, j )
           CALL coriolis( i, j, 3 )
 
@@ -1163,9 +967,7 @@
 !--       Prognostic equation for w-velocity component
           DO  k = nzb_w_inner(j,i)+1, nzt-1
-             w_p(k,j,i) = ( 1.0-tsc(1) ) * w_m(k,j,i) + tsc(1) * w(k,j,i) + &
-                          dt_3d * (                                         &
-                                tsc(2) * tend(k,j,i) + tsc(3) * tw_m(k,j,i) &
-                                  ) -                                       &
-                          tsc(5) * rdf(k) * w(k,j,i)
+             w_p(k,j,i) = w(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +          &
+                                               tsc(3) * tw_m(k,j,i) )          &
+                                   - tsc(5) * rdf(k) * w(k,j,i)
           ENDDO
 
@@ -1191,5 +993,5 @@
 !--          Tendency terms for potential temperature
              tend(:,j,i) = 0.0
-             IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' )  THEN
+             IF ( timestep_scheme(1:5) == 'runge' )  THEN
                    IF ( ws_scheme_sca )  THEN
                       CALL advec_s_ws( i, j, pt, 'pt', flux_s_pt, diss_s_pt, &
@@ -1201,12 +1003,5 @@
                 CALL advec_s_up( i, j, pt )
              ENDIF
-             IF ( tsc(2) == 2.0  .AND.  timestep_scheme(1:8) == 'leapfrog' ) &
-             THEN
-                CALL diffusion_s( i, j, ddzu, ddzw, kh_m, pt_m, shf_m, &
-                                  tswst_m, wall_heatflux, tend )
-             ELSE
-                CALL diffusion_s( i, j, ddzu, ddzw, kh, pt, shf, tswst, &
-                                  wall_heatflux, tend )
-             ENDIF
+             CALL diffusion_s( i, j, pt, shf, tswst, wall_heatflux )
 
 !
@@ -1241,10 +1036,8 @@
 !--          Prognostic equation for potential temperature
              DO  k = nzb_s_inner(j,i)+1, nzt
-                pt_p(k,j,i) = ( 1.0-tsc(1) ) * pt_m(k,j,i) + tsc(1)*pt(k,j,i) +&
-                              dt_3d * (                                        &
-                                  tsc(2) * tend(k,j,i) + tsc(3) * tpt_m(k,j,i) &
-                                      ) - &
-                              tsc(5) * ( pt(k,j,i) - pt_init(k) ) * &
-                              ( rdf_sc(k) + ptdf_x(i) + ptdf_y(j) )  
+                pt_p(k,j,i) = pt(k,j,i) + dt_3d * ( tsc(2) * tend(k,j,i) +     &
+                                                    tsc(3) * tpt_m(k,j,i) )    &
+                                        - tsc(5) * ( pt(k,j,i) - pt_init(k) ) *&
+                                          ( rdf_sc(k) + ptdf_x(i) + ptdf_y(j) )
              ENDDO
 
@@ -1274,8 +1067,7 @@
 !--          Tendency-terms for salinity
              tend(:,j,i) = 0.0
-             IF ( tsc(2) == 2.0  .OR.  timestep_scheme(1:5) == 'runge' ) &
+             IF ( timestep_scheme(1:5) == 'runge' ) &
              THEN
                 IF ( ws_scheme_sca )  THEN
-            !        CALL local_diss( i, j, sa )
                     CALL advec_s_ws( i, j, sa, 'sa', flux_s_sa,  &
                                 diss_s_sa, flux_l_sa, diss_l_sa, i_omp_start, tn  )
@@ -1286,6 +1078,5 @@
                 CALL advec_s_up( i, j, sa )
              ENDIF
-             CALL diffusion_s( i, j, ddzu, ddzw, kh, sa, saswsb, saswst, &
-                               wall_salinityflux, tend )
+             CALL diffusion_s( i, j, sa, saswsb, saswst, wall_salinityflux )
 
              CALL user_actions( i, j, 'sa-tendency' )
